package com.eco.plugin.xxxx.xxxx.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "单点登录配置")
@EnableMetrics
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.eco.plugin.xxxx.xxxx.config", text = "单点登录配置", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "appName", name = "appName", description = "appName", status = Status.SHOW)
    private Conf<String> appName = Holders.simple("xxxx");

    @Identifier(value = "privatekey", name = "密钥", description = "密钥", status = Status.SHOW)
    private Conf<String> privatekey = Holders.simple("");

    @Identifier(value = "index", name = "帆软首页", description = "帆软首页", status = Status.SHOW)
    private Conf<String> index = Holders.simple("http://localhost:8075/webroot/decision");

    @Identifier(value = "authUrl", name = "统一域用户认证请求地址", description = "统一域用户认证请求地址", status = Status.SHOW)
    private Conf<String> authUrl = Holders.simple("http://xxxx");


    public String getAppName() {
        return appName.get();
    }

    public void setAppName(String url) {
        this.appName.set(url);
    }

    public String getPrivatekey() {
        return privatekey.get();
    }

    public void setPrivatekey(String url) {
        this.privatekey.set(url);
    }

    public String getAuthUrl() {
        return authUrl.get();
    }

    public void setAuthUrl(String url) {
        this.authUrl.set(url);
    }

    public String getIndex() {
        return index.get();
    }

    public void setIndex(String url) {
        this.index.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
