package com.eco.plugin.xxxx.xxxx.filter;

import com.eco.plugin.xxxx.xxxx.config.PluginSimpleConfig;
import com.eco.plugin.xxxx.xxxx.utils.EncryUtils;
import com.eco.plugin.xxxx.xxxx.utils.FRUtils;
import com.eco.plugin.xxxx.xxxx.utils.Utils;
import com.fr.decision.fun.impl.AbstractGlobalRequestFilterProvider;
import com.fr.plugin.context.PluginContexts;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.stable.fun.Authorize;

import javax.servlet.FilterChain;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

@EnableMetrics
@Authorize(callSignKey = "com.eco.plugin.xxxx.xxxx")
public class SSOFilter extends AbstractGlobalRequestFilterProvider {
    @Override
    public String filterName() {
        return "xxxx Filter";
    }

    @Override
    public String[] urlPatterns() {
        return new String[]{"/*"};
    }

    @Override
    public void doFilter(HttpServletRequest req, HttpServletResponse res, FilterChain chain ){

        if(PluginContexts.currentContext().isAvailable()){
            //是否放行
            boolean release = isRelease(req);

            if(release){
                release(req,res,chain);
                return;
            }

            //code
            String code = req.getParameter("userInfoGwamcc");

            PluginSimpleConfig psc = PluginSimpleConfig.getInstance();


            if(Utils.isNullStr(code)){
                //跳转认证中心
                redirect(req,res,psc);
                return;
            }

            FRUtils.FRLogInfo("url:"+FRUtils.getAllUrl(req));
            //获取userInfo
            String username = getUsername(code,psc);

            //登录
            FRUtils.login(req,res,username,"");
        }

        release(req,res,chain);
    }

    private String getUsername(String code, PluginSimpleConfig psc) {
        try {
            return EncryUtils.getStr(code);
        } catch (Exception e) {
            FRUtils.FRLogError("解密异常:"+e.getMessage());
            return "";
        }
    }

    private boolean isRelease(HttpServletRequest req) {
        String url = FRUtils.getAllUrl(req);
//        FRUtils.FRLogInfo("requestUrl:"+url);
        String reft = req.getParameter("ref_t");

        boolean isLogin = FRUtils.isLogin(req);
        boolean isRemote = url.contains("remote");
        boolean isLoginPage = url.contains("login")||url.contains("decision/file")||url.contains("decision/resource")||url.contains("decision/system")||url.contains("query/ip");
        boolean isMobile = Utils.isMobile(req);

        return isLogin || isRemote || isLoginPage || isMobile;
    }

    //跳转认证中心
    private void redirect(HttpServletRequest req,HttpServletResponse res, PluginSimpleConfig psc) {
        String url = FRUtils.getAllUrl(req);
        String authurl = psc.getAuthUrl()+"?appName="+psc.getAppName()+"&redirectURL="+url;

        try {
            res.sendRedirect(authurl);
        } catch (IOException e) {
            FRUtils.FRLogInfo("跳转认证中心异常:"+e.getMessage());
        }
    }

    //放行拦截器
    private void release(HttpServletRequest req, HttpServletResponse res, FilterChain chain) {
        try{
            chain.doFilter(req,res);
        }catch (Exception e){
            FRUtils.FRLogInfo("拦截失败");
        }
    }
}

