package com.eco.plugin.xxxx.xxxx.utils;

import com.eco.plugin.xxxx.xxxx.config.PluginSimpleConfig;
import com.fr.json.JSONObject;
import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;
import javax.crypto.Mac;
import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;
import java.io.IOException;
import java.security.InvalidKeyException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 解密类
 */
public class EncryUtils {
    /***
     * Base64转码
     */
    private static byte[] Base64UrlDecode(String input) throws IOException,Exception {
        String output = input;
        output = output.replace('-', '+'); // 62nd char of encoding
        output = output.replace('_', '/'); // 63rd char of encoding
        switch (output.length() % 4) // Pad with trailing '='s
        {
            case 0:
                break; // No pad chars in this case
            case 2:
                output += "==";
                break; // Two pad chars
            case 3:
                output += "=";
                break; // One pad char
            default:
                throw new Exception("Illegal base64url string!");
        }
        BASE64Decoder decoder = new BASE64Decoder();// Standard base64 decoder
        byte[] decodedBytes = decoder.decodeBuffer(output);
        return decodedBytes;
    }

    /***
     * MD5加码 生成md5码
     */
    public static String string2MD5(String inStr){
        MessageDigest md5 = null;
        try{
            md5 = MessageDigest.getInstance("MD5");
        }catch (Exception e){
            System.out.println(e.toString());
            e.printStackTrace();
            return "";
        }
        char[] charArray = inStr.toCharArray();
        byte[] byteArray = new byte[charArray.length];

        for (int i = 0; i < charArray.length; i++)
            byteArray[i] = (byte) charArray[i];
        byte[] md5Bytes = md5.digest(byteArray);
        StringBuffer hexValue = new StringBuffer();
        for (int i = 0; i < md5Bytes.length; i++){
            int val = ((int) md5Bytes[i]) & 0xff;
            if (val < 16)
                hexValue.append("0");
            hexValue.append(Integer.toHexString(val));
        }
        return hexValue.toString();

    }

    public static List getStrMD5PrivateKeyNew(String userid) {
        List list = new ArrayList();
        String strSourceA = "";
        String strSourceB = "";
        String strSourceC = "";
        //账号
        String accountNo = userid;
        //当前时间
        Date nowDate = new Date();
        Date laterDate = new Date(nowDate.getTime() + 60000);
        Date earlyDate = new Date(nowDate.getTime() - 60000);

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmm");
        String strMinutes = sdf.format(nowDate);
        String laterMinutes = sdf.format(laterDate);
        String earlyMinutes = sdf.format(earlyDate);

        //获取系统握手密钥的方法，需要自己实现

        String strMD5PrivateKey = PluginSimpleConfig.getInstance().getPrivatekey();
        //密码与GwamccSSO中分配密码一致

        strSourceA = accountNo + strMinutes + strMD5PrivateKey;
        strSourceA = string2MD5(strSourceA);
        strSourceB = accountNo + laterMinutes + strMD5PrivateKey;
        strSourceB = string2MD5(strSourceB);
        strSourceC = accountNo + earlyMinutes + strMD5PrivateKey;
        strSourceC = string2MD5(strSourceC);
        list.add(strSourceA.toLowerCase());
        list.add(strSourceB.toLowerCase());
        list.add(strSourceC.toLowerCase());
        return list;
    }

    private static byte[] HmacSHA256Signer(byte[] keyBytes, byte[] source)
            throws InvalidKeyException {
        String HMAC_SHA256_ALG = "HmacSHA256";
        Mac hmac;
        SecretKey signingKey = new SecretKeySpec(keyBytes, HMAC_SHA256_ALG);
        try {
            hmac = Mac.getInstance(HMAC_SHA256_ALG);
        } catch (NoSuchAlgorithmException e) {
            throw new IllegalStateException(
                    "cannot use Hmac256Signer on system without HmacSHA256 alg",
                    e);
        }
        hmac.init(signingKey);
        return hmac.doFinal(source);
    }

    public static String getStr(String token)throws IOException, InvalidKeyException, Exception{

        String[] parts = token.split("\\.");
        String header = parts[0];
        String payload = parts[1];

        byte[] crypto = Base64UrlDecode(parts[2]);

        String headerJson = new String(Base64UrlDecode(header), "UTF-8");
        String payloadJson = new String(Base64UrlDecode(payload), "UTF-8");

        // verify
        JSONObject headerData = new JSONObject(headerJson);
        JSONObject payloadData = new JSONObject(payloadJson);

        String userName = payloadData.getString("userName");
        String challenge = payloadData.getString("challenge");

        //验证握手信息，必须做校验！！！
        List list = new ArrayList();
        list = getStrMD5PrivateKeyNew(userName);
        String resultStr = "";
        for(int i=0;i<list.size();i++){
            if(challenge.equals(list.get(i).toString())){
                resultStr = list.get(i).toString();
            }
        }

        if(resultStr == ""){
            return "";
        }else{

            String key = PluginSimpleConfig.getInstance().getPrivatekey();   //密码与GwamccSSO中分配密码一致

            String algorithm = headerData.getString("alg");
            if (!algorithm.equalsIgnoreCase("HS256")) {
                throw new Exception("需要使用约定的HS256算法,这里使用的是" + algorithm);
            }

            byte[] bytesToSign = (header + "." + payload).getBytes("UTF-8");

            BASE64Encoder encoder = new BASE64Encoder();// Standard base64 decoder
            String decodedCrypto = encoder.encode(crypto);
            byte[] signature = HmacSHA256Signer(key.getBytes(), bytesToSign);
            String decodedSignature = encoder.encode(signature);
            if (!decodedCrypto.equals(decodedSignature)) {
                throw new Exception("Hash验证失败");
            }
            return userName;
        }

    }
}
